
#ifndef _CONFIG_C_
#define _CONFIG_C_ 1


#include "config.h"
#include "map.h"
#include "flash.h"

#pragma DATA_SEG SHORT FLASH_RAM
BYTE array[4];
#pragma DATA_SEG DEFAULT

#pragma CONST_SEG EEPROM
const BYTE Farray[64];      // 64 bytes would be the minimal size, but may be bigger
#pragma CONST_SEG DEFAULT

#pragma INLINE
void DisableInt(void)
{
  asm SEI;
  ISCR_IMASK1 = 1;   
} 

#pragma INLINE
void EnableInt(void)
{
  asm CLI;   
  ISCR_IMASK1 = 0;   
} 

void EraseFlash(const unsigned char *page)
{
  asm SEI;   

  CTRLBYT = 0x00;
  CPUSPD = CPUSPEED ; // MHz
  erarnge(page);

  asm CLI;   
}

void WriteFlashSize(const unsigned char *page, unsigned char size)
{
  asm SEI;   
  
  CTRLBYT = 0x00;
  CPUSPD = CPUSPEED ; // MHz
  LADDR = (UINT)(page+size-1);
  prgrnge(page);

  asm CLI;   
}

void WriteFlash(const unsigned char *page)
{
    WriteFlashSize(page, PAGESIZE);
}

unsigned char Read_FLASH (unsigned int Where)
{
    return(Farray[Where]);
}

void Write_FLASH(unsigned int Where, unsigned char What)
{
    array[0] = What;            // copy down data to RAM buffer first
    WriteFlashSize(&Farray[Where], 1);   // Flash via ROM call 
}

void Erase_FLASH(unsigned int Length)
{
unsigned int i;

    for (i=0; i<Length; i+=ERASEPAGESIZE)
    {
        EraseFlash(&Farray[i]);     // erase flash page by page until the end is reached
    }
}


#endif